<?php

defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/payment.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/helpers/j2store.php');

class plgJ2StorePayment_aqayepardakht extends J2StorePaymentPlugin
{
    /**
     * @var $_element  string  Should always correspond with the plugin's filename,
     *                         forcing it to be unique
     */
    var $_element   = 'payment_aqayepardakht';
    private $merchantCode = '';
    private $callBackUrl = '';
    private $redirectToDakhlestan = '';

    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage( '', JPATH_ADMINISTRATOR );
        $this->merchantCode = trim($this->params->get('merchant_id'));
        $this->callBackUrl = JUri::root().'/index.php?option=com_j2store&view=checkout&task=confirmPayment&orderpayment_type=payment_aqayepardakht&paction=callback';
        $this->redirectToDakhlestan = 'https://panel.aqayepardakht.ir/startpay/';
    }

    public function _renderForm( $data )
    {
        $vars = new JObject();
        $vars->message = JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_MESSAGE");
        $html = $this->_getLayout('form', $vars);
        return $html;
    }

    public function _prePayment($data)
    {
        $vars = new StdClass();
        $vars->display_name = $this->params->get('display_name', '');
        $vars->onbeforepayment_text = JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_PREPARATION_MESSAGE");

        $amount = $data['orderpayment_amount'] / 10;
        $amount = (int)$amount;
        $merchantCode = trim($this->params->get('merchant_id'));
        $desc = "پرداخت سفارش شماره " . $data['order_id'] . " به مبلغ "  . $amount . " با آقای پرداخت";
        $email = '';
        $mobile = '';

        $f = array(
            'amount' => $amount,
            'pin' => $merchantCode,
            'callback' => $this->callBackUrl,
            'bank' => 'mellat',
            'description' => $desc
        );

        $f_ = '';
        foreach($f as $k=>$v)
            $f_ .= $k . '=' . urlencode($v) . '&';

        rtrim($f_, '&');

        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/create/");
        curl_setopt($ch,CURLOPT_POST, count($f));
        curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);


        if(strlen($result) > 5) {
            $vars->redirectToDakhlestan = $this->redirectToDakhlestan . $result;
            $html = $this->_getLayout('prepayment', $vars);
            return $html;
        }

        $vars->error = $this->statusText($result);
        $html = $this->_getLayout('prepayment', $vars);
        return $html;
    }

    public function _postPayment($data)
    {
        $vars = new JObject();
        //get order id
        $orderId = $data['order_id'];
        // get instatnce of j2store table
        F0FTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/tables');
        $order = F0FTable::getInstance('Order', 'J2StoreTable')->getClone();
        $order->load(array('order_id' => $orderId));

        if($order->load(array('order_id' => $orderId))){

            $currency = J2Store::currency();
            $currencyValues= $this->getCurrency($order);
            $orderPaymentAmount = $currency->format($order->order_total, $currencyValues['currency_code'], $currencyValues['currency_value'], false);
            $orderPaymentAmount = (int)($orderPaymentAmount / 10);

            $order->add_history(JText::_('J2STORE_CALLBACK_RESPONSE_RECEIVED'));

            $merchantCode = $this->params->get('merchant_id');

            $app = JFactory::getApplication();

            if($_POST['transid']) {

                $transid = $_POST['transid'];
                $f = array(
                    'amount' => (int)$orderPaymentAmount,
                    'pin' => $merchantCode,
                    'transid' => $transid,
                );

                $f_ = '';
                foreach ($f as $k => $v)
                    $f_ .= $k . '=' . urlencode($v) . '&';

                rtrim($f_, '&');

                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, "https://panel.aqayepardakht.ir/api/verify/");
                curl_setopt($ch, CURLOPT_POST, count($f));
                curl_setopt($ch, CURLOPT_POSTFIELDS, $f_);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $res = curl_exec($ch);
                curl_close($ch);


                if ($res == 1) {
                    $order->payment_complete();
                    $order->empty_cart();
                    $message = JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_SUCCESS") . "\n";
                    $message .= JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_DA_REF") . $transid;
                    $vars->message = $message;
                    $html = $this->_getLayout('postpayment', $vars);
                    // $app->close();
                    return $html;
                }
            }
            $message = JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_FAILED") . "\n";
            $message .= JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_ERROR");
            $message .= $this->statusText($res) . "\n";
            $message .= JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_CONTACT") . "\n";
            $vars->message = $message;
            $html = $this->_getLayout('postpayment', $vars);
            // $app->close();
            return $html;

        }

        $vars->message = JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_PAGE_ERROR");
        $html = $this->_getLayout('postpayment', $vars);
        return $html;
    }


    private function statusText($status)
    {
        return JText::_("J2STORE_AQAYEPARDAKHT_PAYMENT_STATUS_" . $status );
    }
}